//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef CLIENTLOCAL_H
#define CLIENTLOCAL_H

#include "Client.h"
#include "ServerLocator.h"

namespace LDHT {

class ServerLocatorLocal : public ServerLocator {
public:
    ServerIndex locateServerForKey(uint64_t key);
};

class TableProtocolLocalAdapter;
class Server;

class ClientLocal : public Client {
public:
    ClientLocal();
    virtual ~ClientLocal();

    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& config_element,
                         ticpp::Element& lm_element);

    virtual void awaitResponses();
    virtual uint64_t getLatencyTicks();
    virtual int getNumWritesToTransport();

private:
    TableProtocolLocalAdapter* m_local_adapter;
    Server* m_server;

};

}  // namespace LDHT.

#endif  // CLIENTLOCAL_H

