//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef FACTORYCOLLECTION_H
#define FACTORYCOLLECTION_H

namespace LDHT {

class HashFunctionFactory;
class TableChunkFactory;
class TableChunkLocatorFactory;

class FactoryCollection {
public:
    static FactoryCollection* createDefaultFactoryCollection();

    FactoryCollection();
    virtual ~FactoryCollection();

    virtual HashFunctionFactory* getHashFunctionFactory();
    virtual void setHashFunctionFactory(
                HashFunctionFactory* hash_function_factory);

    virtual TableChunkFactory* getTableChunkFactory();
    virtual void setTableChunkFactory(
                TableChunkFactory* table_chunk_factory);

    virtual TableChunkLocatorFactory* getTableChunkLocatorFactory();
    virtual void setTableChunkLocatorFactory(
                TableChunkLocatorFactory* table_chunk_locator_factory);

private:
    HashFunctionFactory* m_hash_function_factory;
    TableChunkFactory* m_table_chunk_factory;
    TableChunkLocatorFactory* m_table_chunk_locator_factory;

};

}  // namespace LDHT.

#endif  // FACTORYCOLLECTION_H

