//
// Oliver Wilson <oliver.wilson@ed.ac.uK>
//

#ifndef HASHFUNCTIONFACTORY_H
#define HASHFUNCTIONFACTORY_H

#include "MethodRegistry.h"

namespace LDHT {

class HashFunction;

class HashFunctionFactory {
public:
    typedef HashFunction* (*FactoryMethod)();
    DECLARE_STATIC_METHOD_REGISTRY(DefaultMethods, FactoryMethod);

    static HashFunctionFactory* createDefaultFactory();

    HashFunctionFactory();
    virtual ~HashFunctionFactory();

    virtual void setMethodRegistry(
            MethodRegistry<FactoryMethod>* method_registry);
    virtual HashFunction* createInstance(std::string& type);
    virtual HashFunction* createInstance(const char* type);

private:
    MethodRegistry<FactoryMethod>* m_method_registry;

};

}  // namespace LDHT.

#endif  // HASHFUNCTIONFACTORY_H

