//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef HASHFUNCTIONUNIVERSAL_H
#define HASHFUNCTIONUNIVERSAL_H

#include "HashFunction.h"

namespace LDHT {

class HashFunctionUniversal : public HashFunction {
public:
    static HashFunction* createInstance();

    HashFunctionUniversal();
    HashFunctionUniversal(uint64_t a, uint64_t b, uint64_t P);

    virtual uint64_t hash(uint64_t x);
    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& xml_element);
    uint64_t geta();
    uint64_t getb();
    uint64_t getP();

private:
    uint64_t m_a;
    uint64_t m_b;
    uint64_t m_P;

};

}  // namespace LDHT.

#endif  // HASHFUNCTIONUNIVERSAL_H

