//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef PROTOCOL_H
#define PROTOCOL_H

namespace LDHT {

class StateChangeCallback;

class Protocol {
public:
    Protocol();
    virtual ~Protocol();

    virtual int getWaitFD() = 0;
    virtual bool ready() = 0;
    virtual bool disconnected() = 0;
    virtual void onReady();
    virtual void onDisconnect();
    virtual void setStateChangeCallback(StateChangeCallback* callback);
    virtual bool shouldMonitor();
    virtual void setDontMonitor();
    virtual void setShouldMonitor();

private:
    bool m_should_monitor;
    StateChangeCallback* m_state_change_callback;

};

class StateChangeCallback {
public:
    virtual ~StateChangeCallback() {};

    virtual void onReady() = 0;
    virtual void onDisconnect() = 0;

};

}  // namespace LDHT.

#endif  // PROTOCOL_H

