//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef PROTOCOLQUEUE_H
#define PROTOCOLQUEUE_H

#include <pthread.h>
#include <deque>

namespace LDHT {

class Protocol;

class ProtocolQueue {
public:
    ProtocolQueue();
    virtual ~ProtocolQueue();

    virtual void put(Protocol* protocol);
    virtual Protocol* get();
    virtual int getQueueLength();

private:
    pthread_mutex_t m_queue_mutex;
    pthread_cond_t m_queue_cond;
    std::deque<Protocol*> m_queue;

};

}  // namespace LDHT.

#endif  // PROTOCOLQUEUE_H

