//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef QUANTISER_H
#define QUANTISER_H

#include <stdint.h>
#include <cstdlib>

namespace LDHT {

class Quantiser {
public:
    Quantiser();
    Quantiser(double, double, int);
    virtual ~Quantiser();

    virtual double codeToValue(uint64_t);
    virtual uint64_t valueToCode(double);

private:
    double m_min_value;
    double m_max_value;
    int m_num_bits;
    int m_min_code;
    int m_max_code;
    double m_value_per_code;
    uint64_t m_bit_mask;

};

}  // namespace LDHT.

#endif  // QUANTISER_H

