//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef SERVERLOCATORHASH_H
#define SERVERLOCATORHASH_H

#include "HashFunction.h"
#include "ServerLocator.h"

namespace LDHT {

class ServerLocatorHash : public ServerLocator {
public:
    ServerLocatorHash(HashFunction* hash_function,
                      int num_servers,
                      int num_chunks,
                      int num_cells);

    virtual ServerIndex locateServerForKey(uint64_t key);

private:
    HashFunction* m_hash_function;
    int m_num_servers;
    int m_num_chunks;   
    int m_num_cells;

};

}  // namespace LDHT.

#endif  // SERVERLOCATORHASH_H

