//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TABLECHUNK_H
#define TABLECHUNK_H

#include "ticpp.h"
#include "TableProtocol.h"

namespace LDHT {

class FactoryCollection;

class TableChunk {
public:
    virtual ~TableChunk() {};

    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& xml_element,
                         int chunk_index) = 0;
    virtual TableProtocol::OpFlags get(uint64_t tag,
                                       uint64_t key,
                                       uint64_t* value_ret) {
        return TableProtocol::OpFlagNotSupported;
    }
    virtual TableProtocol::OpFlags set(uint64_t tag,
                                       uint64_t key,
                                       uint64_t value) {
        return TableProtocol::OpFlagNotSupported;
    }
    virtual TableProtocol::OpFlags increment(uint64_t tag,
                                             uint64_t key,
                                             uint64_t increment) {
        return TableProtocol::OpFlagNotSupported;
    }
    virtual TableProtocol::OpFlags incrementApprox(uint64_t tag,
                                                   uint64_t key,
                                                   uint64_t increment) {
        return TableProtocol::OpFlagNotSupported;
    }
    virtual TableProtocol::OpFlags sync(uint64_t tag) {
        return TableProtocol::OpFlagNotSupported;
    }
    virtual bool writeOut() {
        return TableProtocol::OpFlagNotSupported;
    }
};

}  // namespace LDHT.

#endif  // TABLECHUNK_H

