//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TABLECHUNKLOCATOR_H
#define TABLECHUNKLOCATOR_H

#include <stdint.h>
#include <cstdlib>

#include "ticpp.h"

namespace LDHT {

class FactoryCollection;

class TableChunkLocator {
public:
    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& xml_element,
                         int num_cells,
                         int num_chunks) = 0;
    virtual int locateTableChunkForKey(uint64_t key) = 0;
	virtual ~TableChunkLocator(){};
};

}  // namespace LDHT.

#endif  // TABLECHUNKLOCATOR_H

