//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TABLECHUNKLOCATORFACTORY_H
#define TABLECHUNKLOCATORFACTORY_H

#include "MethodRegistry.h"

namespace LDHT {

class TableChunkLocator;

class TableChunkLocatorFactory {
public:
    typedef TableChunkLocator* (*FactoryMethod)();
    DECLARE_STATIC_METHOD_REGISTRY(DefaultMethods, FactoryMethod);
    static TableChunkLocatorFactory* createDefaultFactory();

    TableChunkLocatorFactory();
    virtual ~TableChunkLocatorFactory();

    virtual void setMethodRegistry(
            MethodRegistry<FactoryMethod>* method_registry);
    TableChunkLocator* createInstance(std::string& type);
    TableChunkLocator* createInstance(const char* type);

private:
    MethodRegistry<FactoryMethod>* m_method_registry;
};

}  // namespace LDHT.

#endif  // TABLECHUNKLOCATORFACTORY_H

