//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TABLECHUNKLOCATORHASH_H
#define TABLECHUNKLOCATORHASH_H

#include "TableChunkLocator.h"

namespace LDHT {

class HashFunction;

class TableChunkLocatorHash : public TableChunkLocator {
public:
    static TableChunkLocator* getInstance();

    TableChunkLocatorHash();
    virtual ~TableChunkLocatorHash();

    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& xml_element,
                         int num_cells,
                         int num_chunks);
    virtual void setHashFunction(HashFunction* hash_function);
    virtual void setNumCells(int num_cells);
    virtual void setNumChunks(int num_chunks);
    virtual int locateTableChunkForKey(uint64_t key);
    #if 0
    virtual int locateTableChunkForKey(uint64_t key) {
        return (m_hash_function->hash(key) % m_num_cells) /
                ((double)m_num_cells / (double)m_num_chunks);
    }
    #endif

private:
    int m_num_cells;
    int m_num_chunks;
    HashFunction* m_hash_function;
};

}  // namespace LDHT.

#endif  // TABLECHUNKLOCATORHASH_H

