//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TABLERANGE_H
#define TABLERANGE_H

#include <vector>

#include "TableProtocol.h"
#include "TypeDef.h"

namespace LDHT {

class TableChunk;
class TableChunkLocator;

class TableRange {
public:
    static int calculateChunkIndexStart(int server_index,
                                        int num_servers,
                                        int num_chunks);
    static int calculateChunkIndexEnd(int server_index,
                                      int num_servers,
                                      int num_chunks);

    TableRange();
    virtual ~TableRange();
    virtual void fromXml(FactoryCollection& factory_collection,
                         ticpp::Element& xml_element,
                         int num_servers,
                         int server_index);
    virtual void addTableChunk(TableChunk* table_chunk);
    virtual void setTableChunkLocator(TableChunkLocator* table_chunk_locator);
    virtual TableChunk* getTableChunkForKey(uint64_t key);
    virtual TableChunk* getTableChunk(int index);
    virtual TableProtocol::OpFlags writeChunks();

private:
    std::vector<TableChunk*> m_table_chunks;
    int m_chunk_index_start;
    int m_chunk_index_end;
    TableChunkLocator* m_table_chunk_locator;

};

}  // namespace LDHT.

#endif  // TABLERANGE_H

