//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TRANSPORT_H
#define TRANSPORT_H

#include <stdint.h>
#include <cstdlib>

namespace LDHT {

// This class is intended to be a thin and simple wrapper round various
// IPC mechanisms, such as sockets and pipes.
//
// It should perform no buffering at all and simply take care of
// establishing and maintaining various types of connection.
class Transport {
public:
    virtual ~Transport() {};

    virtual size_t sendBytes(uint8_t*, size_t) = 0;
    virtual bool canSend() = 0;
    virtual size_t recvBytes(uint8_t*, size_t) = 0;
    virtual bool canRecv() = 0;
    virtual void flush() = 0;
    virtual int getReadFd() = 0;
};

}  // namespace LDHT.

#endif  // TRANSPORT_H

