//
// Oliver Wilson <oliver.wilson@ed.ac.uk>
//

#ifndef TRANSPORTPIPE_H
#define TRANSPORTPIPE_H

#include "Transport.h"

namespace LDHT {

class TransportPipe : public Transport {
public:
    TransportPipe();
    virtual ~TransportPipe();

    virtual size_t sendBytes(uint8_t*, size_t);
    virtual bool canSend();
    virtual size_t recvBytes(uint8_t*, size_t);
    virtual bool canRecv();
    virtual void flush();
    virtual int getReadFd();

    int getRdFd() { return m_rd_fd; };
    int getWrFd() { return m_wr_fd; };

private:
    int m_rd_fd;
    int m_wr_fd;
};

}  // namespace LDHT.

#endif  // TRANSPORTDUMMY_H

